<template>
  <v-menu
    ref="dateMenu"
    :close-on-content-click="false"
    v-model="dateMenu"
    :nudge-right="40"
    :return-value.sync="date"
    transition="scale-transition"
    offset-y
    min-width="290px"
  >
    <template v-slot:activator="{ on }">
      <v-text-field
        v-model="date"
        prepend-icon="mdi-calendar"
        readonly
        v-on="on"
        v-bind="$attrs"
      ></v-text-field>
    </template>
    <v-date-picker
      v-model="date"
      no-title
      scrollable
      v-bind="$attrs"
      @input="save(date)"
    ></v-date-picker>
  </v-menu>
</template>

<script>
/**
 * Date Input
 * @displayName Date Input
 * @example ../examples/DateInput.md
 */
/*TODO: Date formatting in input field*/
export default {
  name: "DateInput",
  props: {
    value: {
      type: String,
      default: ""
    }
  },
  data() {
    return {
      dateMenu: false,
      date: this.value
    };
  },
  watch: {
    value(v) {
      if (v !== this.date) {
        this.date = v;
      }
    }
  },
  methods: {
    save(value) {
      this.$refs.dateMenu.save(value);
      this.$emit("input", value);
      this.dateMenu = false;
    }
  }
};
</script>
